<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="任务扩展模板id" prop="templateId">
        <el-input v-model="formData.templateId" placeholder="请输入任务扩展模板id" />
      </el-form-item>
      <el-form-item label="公司id" prop="deptId">
        <el-input v-model="formData.deptId" placeholder="请输入公司id" />
      </el-form-item>
      <el-form-item label="项目id" prop="projectId">
        <el-input v-model="formData.projectId" placeholder="请输入项目id" />
      </el-form-item>
      <el-form-item label="项目类别(钻井 修井 注氮 酸化压裂 )" prop="projectClassification">
        <el-input v-model="formData.projectClassification" placeholder="请输入项目类别(钻井 修井 注氮 酸化压裂 )" />
      </el-form-item>
      <el-form-item label="井型" prop="wellType">
        <el-select v-model="formData.wellType" placeholder="请选择井型">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item>
      <el-form-item label="井别" prop="wellCategory">
        <el-input v-model="formData.wellCategory" placeholder="请输入井别" />
      </el-form-item>
      <el-form-item label="施工工艺" prop="technique">
        <el-input v-model="formData.technique" placeholder="请输入施工工艺" />
      </el-form-item>
      <el-form-item label="属性名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入属性名称" />
      </el-form-item>
      <el-form-item label="属性标识符" prop="identifier">
        <el-input v-model="formData.identifier" placeholder="请输入属性标识符" />
      </el-form-item>
      <el-form-item label="不同专业公司的扩展属性" prop="extProperty">
        <el-input v-model="formData.extProperty" placeholder="请输入不同专业公司的扩展属性" />
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
      <el-form-item label="施工状态(工作量开始/动迁/准备/施工)" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio value="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { IotProjectTaskAttrsApi, IotProjectTaskAttrsVO } from '@/api/pms/iotprojecttaskattrs'

/** 项目任务扩展属性 表单 */
defineOptions({ name: 'IotProjectTaskAttrsForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  templateId: undefined,
  deptId: undefined,
  projectId: undefined,
  projectClassification: undefined,
  wellType: undefined,
  wellCategory: undefined,
  technique: undefined,
  name: undefined,
  identifier: undefined,
  extProperty: undefined,
  remark: undefined,
  status: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await IotProjectTaskAttrsApi.getIotProjectTaskAttrs(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as IotProjectTaskAttrsVO
    if (formType.value === 'create') {
      await IotProjectTaskAttrsApi.createIotProjectTaskAttrs(data)
      message.success(t('common.createSuccess'))
    } else {
      await IotProjectTaskAttrsApi.updateIotProjectTaskAttrs(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    templateId: undefined,
    deptId: undefined,
    projectId: undefined,
    projectClassification: undefined,
    wellType: undefined,
    wellCategory: undefined,
    technique: undefined,
    name: undefined,
    identifier: undefined,
    extProperty: undefined,
    remark: undefined,
    status: undefined,
  }
  formRef.value?.resetFields()
}
</script>
